<?php

class Joovii_Sendleapi_Model_Observer
{

	public function salesOrderItemCancel(Varien_Event_Observer $observer)
    {
		$order = $observer->getEvent()->getItem()->getOrder();
		$sendleOrderId = $order->getSendleOrderId();
		if(trim($sendleOrderId) != ''){

			if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
				Mage::log($sendleOrderId."------- Order Cancel [salesOrderItemCancel=2]---------==".$order->getId(‌​) , null, "sendleapi1001.log");
			}
			//eval(trim(Mage::helper('sendleapi')->validateextensionkeySendlePostCancelcode()));
			$apiurl = Mage::getStoreConfig('carriers/sendle/apiurl');
			$apiusername = Mage::getStoreConfig('carriers/sendle/apikey');
			$apipassword = Mage::getStoreConfig('carriers/sendle/sendleid');
			$apiparam = $apiurl.'/orders/'.$sendleOrderId;

			$return = Mage::helper('sendleapi')->postingCurl($apiparam,'DELETE','');
			$response = json_decode($return, true);

			curl_close($process);
			if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
				Mage::log("------- Order Cancel [salesOrderItemCancel=3]---------==".print_r($response, true) , null, "sendleapi1001.log");
			}
			if(trim($response['messages']) != ''){
				Mage::getSingleton('core/session')->addError($response['messages']);
			}
			if(trim($response['cancellation_message']) != ''){
				Mage::getSingleton('core/session')->addSuccess('Sendle Order has been successfully Cancelled.');
				Mage::getSingleton('core/session')->addSuccess($response['cancellation_message']);
			}
		}
	}

	public function checkoutControllerOnepageSaveShippingMethod(Varien_Event_Observer $observer)
    {
		if (!Mage::getStoreConfig('carriers/sendle/active')) {
            return false;
        }
		if (trim(Mage::helper('sendleapi')->validateextensionkey()) != "validate") {
            return false;
        }
		//$order = $observer->getOrder();
		//Mage::log("------- Order start[salesOrderPlaceAfter] :: ".$order->getIncrementId()."---------" , null, "sendleapi1001.log");
		$post = Mage::app()->getRequest()->getPost();
		$quote = $observer->getQuote();
		//$quote = $observer->getSession()->getQuote();
		$quote->setData('sendle_delivery_instruction', $post['delivery_instruction']);
		$quote->setSendleDeliveryInstruction($post['delivery_instruction']);
		if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
			Mage::log("------- Order END[checkoutControllerOnepageSaveShippingMethod]---------".$post['delivery_instruction'], null, "sendleapi1001.log");
		}

	}

	public function salesOrderAfter(Varien_Event_Observer $observer)
    {
		if (!Mage::getStoreConfig('carriers/sendle/active')) {
            return false;
        }
		if (trim(Mage::helper('sendleapi')->validateextensionkey()) != "validate") {
            return false;
        }


		if (Mage::getStoreConfig('carriers/sendle/postendpoint') == 'ordersubmit') {

			$order = $observer->getOrder();
			if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
				Mage::log("-------getShippingMethod ---------".$order->getShippingMethod() , null, "sendleapi1001.log");
				Mage::log("-------processassendleorder ---------".print_r(Mage::getStoreConfig('carriers/sendle/processassendleorder'), true) , null, "sendleapi1001.log");
				// flatrate_flatrate,freeshipping_freeshipping == flat_rate,free_rate
			}
			$psoArr = explode(",",Mage::getStoreConfig('carriers/sendle/processassendleorder'));
			$postToSendle = 0;
			if(in_array("flat_rate", $psoArr) && $order->getShippingMethod()=="flatrate_flatrate"){
				$postToSendle = 1;
			}
			if(in_array("free_rate", $psoArr) && $order->getShippingMethod()=="freeshipping_freeshipping"){
				$postToSendle = 1;
			}

			if(trim($order->getShippingMethod()) == 'sendle_sendleapi' || $postToSendle == 1){

				if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
					Mage::log("------- Order start[salesOrderPlaceAfter :: ordersubmit] :: ".$order->getIncrementId()."---------" , null, "sendleapi1001.log");
				}
				$response = Joovii_Sendleapi_Model_Observer::createorderjason($order, 'ordersubmit');
				if($response[0] == 0){
					$this->createshipment( $order);
				}else{
					Mage::getSingleton('core/session')->addError('Something wrong when trying to post shipment to Sendle API.');
					//Mage::getSingleton('core/session')->addError('Error:'. print_r($response[1]));
				}
				if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
					Mage::log("------- Order END[salesOrderPlaceAfter :: ordersubmit ]---------" , null, "sendleapi1001.log");
				}
			}
		}
	}

	protected function createshipment( $order) {

		$qty=array();
		foreach($order->getAllItems() as $eachOrderItem){

			$Itemqty=0;
			$Itemqty = $eachOrderItem->getQtyOrdered()
					- $eachOrderItem->getQtyShipped()
					- $eachOrderItem->getQtyRefunded()
					- $eachOrderItem->getQtyCanceled();
			$qty[$eachOrderItem->getId()]=$Itemqty;
		}
		$email=true;
		$includeComment=true;
		$comment="Shipment created for Sendle";

		if ($order->canShip()) {
			/* @var $shipment Mage_Sales_Model_Order_Shipment */
			/* prepare to create shipment */
			$shipment = $order->prepareShipment($qty);
			if ($shipment) {
				$shipment->register();
				$shipment->addComment($comment, $email && $includeComment);
				$shipment->getOrder()->setIsInProcess(true);
				try {
					$transactionSave = Mage::getModel('core/resource_transaction')
						->addObject($shipment)
						->addObject($shipment->getOrder())
						->save();
					//$shipment->sendEmail($email, ($includeComment ? $comment : ''));
				} catch (Mage_Core_Exception $e) {
					if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
						Mage::log("------- Order END[createshipment :: erroe]---------".print_r($e, true) , null, "sendleapi1001.log");
					}
				}
			 }
		}
		if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
			Mage::log("------- Order END[createshipment]---------" , null, "sendleapi1001.log");
		}
	}

	public function salesOrderShipmentSaveBefore(Varien_Event_Observer $observer)
    {
		if (!Mage::getStoreConfig('carriers/sendle/active')) {
            return false;
        }
		if (trim(Mage::helper('sendleapi')->validateextensionkey()) != "validate") {
            return false;
        }


		$shipment = $observer->getEvent()->getShipment();
		$order = $shipment->getOrder();
		$sendleOrderId = $order->getSendleOrderId();


		if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
			Mage::log("-------getShippingMethod 2 ---------".$order->getShippingMethod() , null, "sendleapi1001.log");
			Mage::log("-------processassendleorder 2 ---------".Mage::getStoreConfig('carriers/sendle/processassendleorder') , null, "sendleapi1001.log");
		}

		$psoArr = explode(",",Mage::getStoreConfig('carriers/sendle/processassendleorder'));
		$postToSendle = 0;
		if(in_array("flat_rate", $psoArr) && $order->getShippingMethod()=="flatrate_flatrate"){
			$postToSendle = 1;
		}
		if(in_array("free_rate", $psoArr) && $order->getShippingMethod()=="freeshipping_freeshipping"){
			$postToSendle = 1;
		}

		if(trim($order->getShippingMethod()) == 'sendle_sendleapi' || $postToSendle ==1){

			if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
				Mage::log("-------post to sendle ---------".$order->getShippingMethod() , null, "sendleapi1001.log");
			}

		}else{
			return false;
		}

		if (Mage::getStoreConfig('carriers/sendle/postendpoint') == 'shipmentsubmit' || is_null($sendleOrderId) ) {

			if(trim($order->getSendleShipmentTrack()) != 'yes'){
				if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
					Mage::log("------- Order start[salesOrderShipmentSaveBefore-1] post to sendle :: ".$order->getIncrementId()."---------" , null, "sendleapi1001.log");
				}
				$response = Joovii_Sendleapi_Model_Observer::createorderjason($order, 'shipmentsubmit');
				//Mage::log("------- Order responseeiii :: ".print_r($response,true)."---------" , null, "sendleapi1001.log");
				if($response[0] == 0){
					$track = Mage::getModel('sales/order_shipment_track')
								->setNumber($response['1']['sendle_reference']) //tracking number
								->setCarrierCode('sendle') //carrier code
								->setTitle('Sendle-'.$order->getId()); //carrier title
					$shipment->addTrack($track);
					$order->setSendleShipmentTrack('yes');
					$order->setData('sendle_shipment_track', 'yes');
					$order->save();
					Mage::getSingleton('core/session')->addSuccess('Shipment has been posted to Sendle API.');
					//Mage::getSingleton('core/session')->addSuccess('Pickup date:'.$response['1']['scheduling']['pickup_date']);
				}else{
					//Mage::getSingleton('core/session')->addError('Something wrong when trying to post Sendle API.');
					//Mage::getSingleton('core/session')->addError('Error:'. print_r($response[1]));
					Mage::throwException('Something wrong when trying to post Sendle API. '. print_r($response[1]));
					return false;
				}
				//Mage::log("------- Order END[salesOrderShipmentSaveBefore-1] post to sendle -->".$order->getSendleShipmentTrack(). "<--" , null, "sendleapi1001.log");
			}

		}elseif (Mage::getStoreConfig('carriers/sendle/postendpoint') == 'ordersubmit') {

			// get order ststus
			if(trim($order->getSendleShipmentTrack()) != 'yes'){
				if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
					Mage::log("------- Order start[salesOrderShipmentSaveBefore-2] get order ststus :: ".$order->getIncrementId()."---------" , null, "sendleapi1001.log");
				}

				//eval(trim(Mage::helper('sendleapi')->validateextensionkeySendlePostTrackingcode()));
				$apiurl = Mage::getStoreConfig('carriers/sendle/apiurl');
				$apiusername = Mage::getStoreConfig('carriers/sendle/apikey');
				$apipassword = Mage::getStoreConfig('carriers/sendle/sendleid');
				$apiparam = $apiurl.'/orders/'.$order->getSendleOrderId();

				$return = Mage::helper('sendleapi')->postingCurl($apiparam,'GET','');

				$response = json_decode($return, true);
				//Mage::log($apiparam."------- Order12 responseeiii :: ".print_r($response,true)."---------" , null, "sendleapi1001.log");
				$track = Mage::getModel('sales/order_shipment_track')
							->setNumber($response['sendle_reference']) //tracking number
							->setCarrierCode('sendle') //carrier code
							->setTitle('Sendle-'.$order->getId()); //carrier title
				$shipment->addTrack($track);
				$order->setSendleShipmentTrack('yes');
				$order->setData('sendle_shipment_track', 'yes');
				$order->save();
				//Mage::getSingleton('core/session')->addSuccess('Shipment tracking number has been added to the system');
				//Mage::getSingleton('core/session')->addSuccess('Pickup date:'.$response['scheduling']['pickup_date']);
				//Mage::log("------- Order END[salesOrderShipmentSaveBefore-2] get order ststus".print_r($response, true) , null, "sendleapi1001.log");

			}
		}

	}

	public static function createorderjason($order, $action='')
	{
		$errerArr = array();
		$errerArr[0]=1;
		if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
			Mage::log(" link : ----createorderjason------" , null, "sendleapi1001.log");
		}
		if(trim($order->getSendleOrderId()) != '') {
			$response = array();
			$response['sendle_reference'] = $order->getSendleReference();
			$response['scheduling']['pickup_date'] = $order->getSendlePickupDate();
			$errerArr[0]=0;
			$errerArr[1]=$response;
			return $errerArr;
		}else{
			$address = $order->getShippingAddress();
			$region = Mage::getModel('directory/region')->load($address->getRegionId());
			$state_name = $region->getName();
			if(trim($state_name) == ''){ $state_name = $address->getRegion();  }
			//if(trim($state_name) == ''){ $state_name = 'NSW';  }
			//$items = Mage::getModel('checkout/cart')->getQuote()->getAllItems();
			$weight = 0;
			$weight1 = $order->getWeight();
			$orderdetails = '';
			$lastsku = '';
			foreach($order->getAllItems() as $item) {
				if(trim($item->getSku()) == trim($lastsku)){ continue; }
				$weight += ($item->getWeight() * $item->getQtyOrdered()) ;
				$orderdetails .= $item->getName().'('.$item->getSku().')['.$item->getWeight().'*'.$item->getQtyOrdered()."];";
				$lastsku = $item->getSku();
			}
			$volumeInCC = Joovii_Sendleapi_Model_Observer::calculatevolume($order->getAllItems());
			$zip = $address->getPostcode();
			$city = $address->getCity();
			$receiverTelephone = $address->getTelephone();

			$sender_suburb = Mage::getStoreConfig('carriers/sendle/sender_suburb');
			$sender_postcode =Mage::getStoreConfig('carriers/sendle/sender_postcode');

			$deliveryInstruction = $order->getSendleDeliveryInstruction();
			if(trim($deliveryInstruction) == ''){
				$deliveryInstruction = Mage::getStoreConfig('carriers/sendle/customer_pickup_instructions', $order->getStoreId());
			}
			if(trim($deliveryInstruction) == ''){
				$deliveryInstruction = "Knock loudly";
			}
			$pickupInstruction = Mage::getStoreConfig('carriers/sendle/sender_pickup_instructions', $order->getStoreId());
			if(trim($deliveryInstruction) == ''){
				$deliveryInstruction = "Knock loudly";
			}
			if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
				Mage::log("------------------ shipment create - deliveryInstruction :: ".$deliveryInstruction."------------------------" , null, "sendleapi1001.log");
			}
			if($weight1 < 0.5 ){ $deliveryInstruction = ''; }

			$orderpostcontent = '{
				"pickup_date": "$$$pickupdate$$$",
				"description": "'.str_replace("\""," ",$_SERVER['SERVER_NAME']).'",
				"kilogram_weight": '.Joovii_Sendleapi_Model_Observer::weightConverter($weight1).',
				"cubic_metre_volume": '.$volumeInCC.',
				"customer_reference": "OrderNumber:'.$order->getIncrementId().'",
				"metadata": {
				  "extensiondetails": "Joovi: mage_joovi_version=1.1.2; mage_version='.Mage::getVersion().' ",
				  "orderdetails": "'.str_replace("\""," ",$orderdetails).'",
				  "magento_order_id": "'.$order->getIncrementId().'",
				  "magento_store_name": "'.str_replace("\""," ",$_SERVER['SERVER_NAME']).'['.str_replace("\n","->",str_replace("\""," ",$order->getStoreName())).']"
				},
				"sender": {
				  "contact": {
					"name": "'.str_replace("\""," ",Mage::getStoreConfig('carriers/sendle/sender_name', $order->getStoreId())).'",
					"phone": "'.str_replace("\""," ",Mage::getStoreConfig('carriers/sendle/sender_contact_number', $order->getStoreId())).'"
				  },
				  "address": {
					"address_line1": "'.str_replace("\""," ",Mage::getStoreConfig('carriers/sendle/sender_address', $order->getStoreId())).'",
					"suburb": "'.str_replace("\""," ",Mage::getStoreConfig('carriers/sendle/sender_suburb', $order->getStoreId())).'",
					"state_name": "'.str_replace("\""," ",Mage::getStoreConfig('carriers/sendle/sender_state', $order->getStoreId())).'",
					"postcode": "'.str_replace("\""," ",Mage::getStoreConfig('carriers/sendle/sender_postcode', $order->getStoreId())).'",
					"country": "Australia"
				  },
				  "instructions": "'.str_replace("\""," ",$pickupInstruction).'"
				},
				"receiver": {
				  "contact": {
					"name": "'.str_replace("\""," ",$address->getFirstname()).' '.str_replace("\""," ",$address->getLastname()).'",
					"email": "'.str_replace("\""," ",$address->getEmail()).'",
					"phone": "$$$receiverTelephone$$$"
				  },
				  "address": {
					"address_line1": "'.str_replace("\""," ",$address->getStreet1()).'",
					"address_line2": "'.str_replace("\""," ",$address->getCompany()).' '.str_replace("\""," ",$address->getStreet2()).'",
					"suburb": "'.str_replace("\""," ",$address->getCity()).'",
					"state_name": "'.str_replace("\""," ",$state_name).'",
					"postcode": "'.str_replace("\""," ",$address->getPostcode()).'",
					"country": "Australia"
				  },
				  "instructions": "'.str_replace("\""," ",$deliveryInstruction).'"
				}
			}';
			$pickupDate = date('Y-m-d');
			$orderpostcontent1 = '';
			$select_pickup_date = Mage::getStoreConfig('carriers/sendle/select_pickup_date');
			if($select_pickup_date > 1){
				$pickupDate = date('Y-m-d',date(strtotime("+".$select_pickup_date." day", strtotime($pickupDate))));
				$orderpostcontent1 = str_replace('$$$pickupdate$$$',$pickupDate,$orderpostcontent);
			}else{
				$pickupDate = '';
				$orderpostcontent1 = str_replace('$$$pickupdate$$$',$pickupDate,$orderpostcontent);
			}
			$orderpostcontent1 = str_replace('$$$receiverTelephone$$$',$receiverTelephone,$orderpostcontent1);

			for($ic=0;$ic<10;$ic++){

				$return = Joovii_Sendleapi_Model_Observer::postOrderCurl($orderpostcontent1);
				$response = json_decode($return, true);
				if(count($response) > 0 ) {

					if(trim($response['error']) != ''){

						$array_keys = Joovii_Sendleapi_Model_Observer::getKeysMultidimensional($response['messages']);
						if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
							Mage::log("------------------ Order Error :: ".$orderpostcontent1."------------------------" , null, "sendleapi1001.log");
							Mage::log("------------------ Order Error :: ".print_r($response, true)."------------------------" , null, "sendleapi1001.log");
						}
						if(trim($response['messages']['pickup_date']['0']) != ''){
							$errerArr[0]=1;
							$errerArr[1]=$response;
							$pickupDate = date('Y-m-d',date(strtotime("+1 day", strtotime($pickupDate))));
							$orderpostcontent1 = str_replace('$$$pickupdate$$$',$pickupDate,$orderpostcontent);
							$orderpostcontent1 = str_replace('$$$receiverTelephone$$$',$receiverTelephone,$orderpostcontent1);
							continue;
						}elseif( trim($array_keys['0']) == 'receiver' && trim($array_keys['4']) == 'phone' ){
							$errerArr[0]=1;
							$errerArr[1]=$response;
							$receiverTelephone = '';
							$orderpostcontent1 = str_replace('$$$pickupdate$$$',$pickupDate,$orderpostcontent);
							$orderpostcontent1 = str_replace('$$$receiverTelephone$$$',$receiverTelephone,$orderpostcontent1);

						}else{
							$errerArr[0]=1;
							break;
						}

					}else{

						$errerArr[0]=0;
						$errerArr[1]=$response;
						if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
							Mage::log("------------------ Order Success :: ".$orderpostcontent1."------------------------" , null, "sendleapi1001.log");
							Mage::log("------------------ Order Success :: ".print_r($errerArr, true)."------------------------" , null, "sendleapi1001.log");
						}
						break;
					}

				} else {
					if (Mage::getStoreConfig('carriers/sendle/enablelog')) {
						Mage::log("------------------ Order Error1 :: ".$orderpostcontent1."------------------------" , null, "sendleapi1001.log");
						Mage::log("------------------ Order Error2 :: ".print_r($response, true)."------------------------" , null, "sendleapi1001.log");
					}
					$errerArr[0]=1;
				}

			}
			$order->setData('sendle_order_id', $response['order_id']);
			$order->setSendleOrderId($response['order_id']);
			$order->setData('sendle_reference', $response['sendle_reference']);
			$order->setSendleReference($response['sendle_reference']);
			$order->setData('sendle_pickup_date', $response['scheduling']['pickup_date']);
			$order->setSendlePickupDate($response['scheduling']['pickup_date']);
			$order->setSendleSubmitStatus($action);
			$order->setSendlePostContent($orderpostcontent1);
			$order->setSendleReturnContent($return);
			if ($action == 'shipmentsubmit') {
				$order->save();
			}
			return $errerArr;
		}
	}

	public static function getKeysMultidimensional(array $array)
	{
		$keys = array();
		foreach($array as $key => $value)
		{
			$keys[] = $key;
			if( is_array($value) ) {
				$keys = array_merge($keys, Joovii_Sendleapi_Model_Observer::getKeysMultidimensional($value));
			}
		}
		return $keys;
	}

	public static function postOrderCurl($orderpostcontent)
	{

		//eval(trim(Mage::helper('sendleapi')->validateextensionkeySendlePostcode()));
		//return $return;

		$apiurl = Mage::getStoreConfig('carriers/sendle/apiurl');
		$apiusername = Mage::getStoreConfig('carriers/sendle/apikey');
		$apipassword = Mage::getStoreConfig('carriers/sendle/sendleid');

		$apiparam = $apiurl.'/orders';
		$return = Mage::helper('sendleapi')->postingCurl($apiparam, 'POST',$orderpostcontent );

		return $return;
	}

	public static function calculatevolume($items)
    {
		$prod_W = 0;
		$prod_D = 0;
		$prod_L = 0;
		$volume  = 0;
		$volume_1  = 0;
		if (Mage::getStoreConfig('carriers/sendle/use_sendle_attributes')) {

			foreach($items as $item) {
				$product = Mage::getSingleton('catalog/product')->load($item->getProduct()->getId());
				$prod_W = Joovii_Sendleapi_Model_Observer::lengthConverter($product->getResource()->getAttribute('sendle_width')->getFrontend()->getValue($product));
        $prod_D = Joovii_Sendleapi_Model_Observer::lengthConverter($product->getResource()->getAttribute('sendle_depth')->getFrontend()->getValue($product));
        $prod_L = Joovii_Sendleapi_Model_Observer::lengthConverter($product->getResource()->getAttribute('sendle_length')->getFrontend()->getValue($product));
				$volume_1  = round((($prod_W*$prod_D*$prod_L)/1000000),3 );
				$volume = $volume + $volume_1;
				//Mage::log("--calculatevolume1----". $item->getSku()."----- :: (".$prod_W."*".$prod_D."*".$prod_L.")= ".$volume_1."------" , null, "sendleapi1001.log");
			}
			//Mage::log("--calculatevolume1----".$volume."------" , null, "sendleapi1001.log");

    }else{

			foreach($items as $item) {
				$prod_W=0; $prod_D=0; $prod_L=0;
				$product = Mage::getSingleton('catalog/product')->load($item->getProduct()->getId());
				if(trim(Mage::getStoreConfig('carriers/sendle/system_sendle_width')) != ''){
					$attrW = Mage::getResourceModel('catalog/eav_attribute')->loadByCode('catalog_product',trim(Mage::getStoreConfig('carriers/sendle/system_sendle_width')));
					if ($attrW->getId()) {
						$prod_W = Joovii_Sendleapi_Model_Observer::lengthConverter($product->getResource()->getAttribute(Mage::getStoreConfig('carriers/sendle/system_sendle_width'))->getFrontend()->getValue($product));
					}
				}
				if(trim(Mage::getStoreConfig('carriers/sendle/system_sendle_depth')) != ''){
					$attrD = Mage::getResourceModel('catalog/eav_attribute')->loadByCode('catalog_product',trim(Mage::getStoreConfig('carriers/sendle/system_sendle_depth')));
					if ($attrD->getId()) {
				  	$prod_D = Joovii_Sendleapi_Model_Observer::lengthConverter($product->getResource()->getAttribute(Mage::getStoreConfig('carriers/sendle/system_sendle_depth'))->getFrontend()->getValue($product));
					}
				}
				if(trim(Mage::getStoreConfig('carriers/sendle/system_sendle_length')) != ''){
					$attrL = Mage::getResourceModel('catalog/eav_attribute')->loadByCode('catalog_product',trim(Mage::getStoreConfig('carriers/sendle/system_sendle_length')));
					if ($attrL->getId()) {
						$prod_L = Joovii_Sendleapi_Model_Observer::lengthConverter($product->getResource()->getAttribute(Mage::getStoreConfig('carriers/sendle/system_sendle_length'))->getFrontend()->getValue($product));
					}
				}
				$volume_1  = round((($prod_W*$prod_D*$prod_L)/1000000),3 );
				$volume = $volume + $volume_1;
				//Mage::log("--calculatevolume2----". $item->getSku()."----- :: (".$prod_W."*".$prod_D."*".$prod_L.")= ".$volume_1."-----" , null, "sendleapi1001.log");
			}
			//Mage::log("--calculatevolume2----".$volume."------" , null, "sendleapi1001.log");

		}
		return $volume;
	}

	public static function lengthConverter($length){
		if (Mage::getStoreConfig('carriers/sendle/volume_converter') == 'metre') {
			$length = round(($length*100),2);
        }
		return $length;
	}

	public static function weightConverter($weight){
		if (Mage::getStoreConfig('carriers/sendle/weight_converter') == 'gram') {
			$weight = round(($weight/1000),3);
        }
		return $weight;
	}

	public static function validate_phone($number) {
	  $number = preg_replace('/[^\d]/', '', $number);
	  //return preg_match('/^(0(2|3|4|7|8))?\d{8}$/', $number) || preg_match('/^1(3|8)00\d{6}$/', $number) || preg_match('/^13\d{4}$/', $number);
	}

}
